﻿Option Explicit On
Option Strict On

Imports PluginAPI
Imports System.Xml.Serialization
Imports System.IO

Public Class Plugin
    Implements IPlugin
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                            SimTools Plugin - Edit the Setting below to provide support for you favorite game!                              ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////
    '/// Per Game Settings - Change for Each Game ///
    '////////////////////////////////////////////////
    Private Const _PluginAuthorsName As String = "yobuddy"
    Private Const _GameName As String = "No Limits Simulator" 'GameName - the displayed Name for this game. Also the DLL_Name ==> "Live for Speed.dll"
    Private Const _ProcessName As String = "NoLimitsSimulator" 'Process_Name without the (".exe") for this game
    Private Const _Port As String = "4123"  'Your Sending/Recieving UDP Port for this game
    '////////////////////////////////////////////////
    '///           Memory Map Variables           ///
    '////////////////////////////////////////////////
    Private Const _Is_MemoryMap As Boolean = False 'Is a MemoryMap file Required for this game?
    Private Const _MMF_Name As String = "NULL" 'Set if using a Memory Map File - EXAMPLE("$gtr2$")
    '////////////////////////////////////////////////
    '///           MemoryHook Variables           ///
    '////////////////////////////////////////////////   
    Private Const _Is_MemoryHook As Boolean = True  'Is a Memory Hook Required for this game? 
    Private Const _MemHook_Roll As UInteger = 0 'Not Used = 0
    Private Const _MemHook_Pitch As UInteger = 0 'Not Used = 0
    Private Const _MemHook_Heave As UInteger = &H5A8760 'This is the memory offset
    Private Const _MemHook_Yaw As UInteger = 0 'Not Used = 0
    Private Const _MemHook_Sway As UInteger = &H5A8764 'This is the memory offset
    Private Const _MemHook_Surge As UInteger = &H5A8768 'This is the memory offset
    Private Const _MemHook_Extra1 As UInteger = 0
    Private Const _MemHook_Extra2 As UInteger = 0
    Private Const _MemHook_Extra3 As UInteger = 0
    '////////////////////////////////////////////////
    '///    DOFs Used for Output for this Game    ///
    '////////////////////////////////////////////////
    Private Const _DOF_Support_Roll As Boolean = False
    Private Const _DOF_Support_Pitch As Boolean = False
    Private Const _DOF_Support_Heave As Boolean = True
    Private Const _DOF_Support_Yaw As Boolean = False
    Private Const _DOF_Support_Sway As Boolean = True
    Private Const _DOF_Support_Surge As Boolean = True
    Private Const _DOF_Support_Extra1 As String = "" 'Blank = False
    Private Const _DOF_Support_Extra2 As String = "" '"" = Not Used
    Private Const _DOF_Support_Extra3 As String = "" 'ADD THE FORCE NAME HERE
    '/////////////////////////////////////////////////
    '///       GameDash - Dash Board Support       ///
    '/////////////////////////////////////////////////
    Private Const _Is_DashBoard As Boolean = False 'Enable the DashBoard Output System?
    'EXAMPLES OF DASHOUTPUT (all variables are strings) - 20 DASH OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (Action, Value) as String
    'Dash_1_Output = "Speed," & OUTPUT_VALUE_HERE.ToString
    'Dash_2_Output = "Rpm," & OUTPUT_VALUE_HERE.ToString
    '...
    'Dash_20_Output = "Gear," & OUTPUT_VALUE_HERE.ToString
    '////////////////////////////////////////////////

    'Used by GameManager when the Game Starts.
    Public Sub StartupCommands() Implements IPlugin.StartupCommands
        'DO SOMETHING HERE AT GAME START!
    End Sub

    'Used by GameMnnager when the Game Stops.
    Public Sub ShutDownCommands() Implements IPlugin.ShutDownCommands
        'DO SOMETHING HERE AT GAME START!
    End Sub

    'Used by GameManager to Process a MemoryHook.
    Public Sub Process_MemoryHook() Implements IPlugin.Process_MemoryHook
        Sway_MemHook = CSng(ReadSingle(ProcessName, _MemHook_Sway))
        Surge_MemHook = (CSng(ReadSingle(ProcessName, _MemHook_Surge)) * -1)
        Heave_MemHook = ((CSng(ReadSingle(ProcessName, _MemHook_Heave)) - 1) * -1)
    End Sub

    'Used by GameManager to Process a MemoryMap.
    Public Sub Process_MemoryMap() Implements IPlugin.Process_MemoryMap
        'DO SOMETHING HERE AT GAME START!
    End Sub

    'Used by GameEngine to Process Incoming UDP Packets.
    Private Input_Data As New GenericOutput
    Sub Process_PacketRecieved(Text As String) Implements IPlugin.Process_PacketRecieved
        Input_Data = CType(DeSerializeString(Text), GenericOutput)
        With Input_Data
            Roll_Output = 0
            Pitch_Output = 0
            Heave_Output = ._Heave
            Yaw_Output = 0
            Sway_Output = ._Sway
            Surge_Output = ._Surge
        End With
    End Sub

    'Used by GameManager to Patch a Game.
    Function PatchGame(ByVal MyPath As String, ByVal MyIp As String) As Boolean Implements IPlugin.PatchGame
        'Change as Needed
        MsgBox("Patch Installed!", MsgBoxStyle.OkOnly, "Patching info")
        Return True
    End Function

    'Used by GameManager to UnPatch a Game.
    Sub UnPatchGame(MyPath As String) Implements IPlugin.UnPatchGame
        'Change as Needed 
        MsgBox("Patch Uninstalled!", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    Sub PatchPathInfo() Implements IPlugin.PatchPathInfo
        MsgBox("Please Select the No Limits Simulator's Installation Directory.", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Used by GameManager to Validate a Path befors Patching.
    Function ValidatePatchPath(MyPath As String) As Boolean Implements IPlugin.ValidatePatchPath
        'insert a simple validation of the patching path - let the user know he got it right
        If System.IO.File.Exists(MyPath & "\NoLimitsSimulator.exe") = True Then
            Return True
        Else
            Return False
        End If
    End Function


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                        DO NOT EDIT BELOW HERE!!!                                                           ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// BUILT IN METHODS - DO NOT CHANGE /////"
    'For MemoryHook
    Public Declare Function ReadProcessMemory Lib "kernel32" Alias "ReadProcessMemory" (ByVal hProcess As Integer, ByVal lpBaseAddress As Integer, ByVal lpBuffer() As Byte, ByVal nSize As Integer, ByRef lpNumberOfBytesWritten As Integer) As Integer
    Public Declare Function CloseHandle Lib "kernel32" Alias "CloseHandle" (ByVal hObject As Integer) As Integer
    Public Declare Function OpenProcess Lib "kernel32" Alias "OpenProcess" (ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal dwProcessId As Integer) As Integer

    'Output Dash Vars
    Public Dash_1_Output As String = ""
    Public Dash_2_Output As String = ""
    Public Dash_3_Output As String = ""
    Public Dash_4_Output As String = ""
    Public Dash_5_Output As String = ""
    Public Dash_6_Output As String = ""
    Public Dash_7_Output As String = ""
    Public Dash_8_Output As String = ""
    Public Dash_9_Output As String = ""
    Public Dash_10_Output As String = ""
    Public Dash_11_Output As String = ""
    Public Dash_12_Output As String = ""
    Public Dash_13_Output As String = ""
    Public Dash_14_Output As String = ""
    Public Dash_15_Output As String = ""
    Public Dash_16_Output As String = ""
    Public Dash_17_Output As String = ""
    Public Dash_18_Output As String = ""
    Public Dash_19_Output As String = ""
    Public Dash_20_Output As String = ""

    'Output Vars
    Public Roll_Output As Double = 0
    Public Pitch_Output As Double = 0
    Public Heave_Output As Double = 0
    Public Yaw_Output As Double = 0
    Public Sway_Output As Double = 0
    Public Surge_Output As Double = 0
    Public Extra1_Output As Double = 0
    Public Extra2_Output As Double = 0
    Public Extra3_Output As Double = 0

    'MemHook Vars
    Public Roll_MemHook As Double = 0
    Public Pitch_MemHook As Double = 0
    Public Heave_MemHook As Double = 0
    Public Yaw_MemHook As Double = 0
    Public Sway_MemHook As Double = 0
    Public Surge_MemHook As Double = 0
    Public Extra1_MemHook As Double = 0
    Public Extra2_MemHook As Double = 0
    Public Extra3_MemHook As Double = 0

    'MemMap Vars
    Public Roll_MemMap As Double = 0
    Public Pitch_MemMap As Double = 0
    Public Heave_MemMap As Double = 0
    Public Yaw_MemMap As Double = 0
    Public Sway_MemMap As Double = 0
    Public Surge_MemMap As Double = 0
    Public Extra1_MemMap As Double = 0
    Public Extra2_MemMap As Double = 0
    Public Extra3_MemMap As Double = 0

    Public Function GetDOFsUsed() As String Implements IPlugin.GetDOFsUsed
        'Return DOF's Used (Roll,Pitch,Heave,Yaw,Sway,Surge)
        Return (_DOF_Support_Roll.ToString & "," & _DOF_Support_Pitch.ToString & "," & _DOF_Support_Heave.ToString & "," & _DOF_Support_Yaw.ToString & "," & _DOF_Support_Sway.ToString & "," & _DOF_Support_Surge.ToString & "," & _DOF_Support_Extra1.ToString & "," & _DOF_Support_Extra2.ToString & "," & _DOF_Support_Extra3.ToString)
    End Function

    Public Sub ResetDOFVars() Implements IPlugin.ResetDOFVars
        Roll_Output = 0
        Pitch_Output = 0
        Heave_Output = 0
        Yaw_Output = 0
        Sway_Output = 0
        Surge_Output = 0
        Extra1_Output = 0
        Extra2_Output = 0
        Extra3_Output = 0
    End Sub

    Public Sub ResetMapVars() Implements IPlugin.ResetMapVars
        Roll_MemMap = 0
        Pitch_MemMap = 0
        Heave_MemMap = 0
        Yaw_MemMap = 0
        Sway_MemMap = 0
        Surge_MemMap = 0
        Extra1_MemMap = 0
        Extra2_MemMap = 0
        Extra3_MemMap = 0
    End Sub

    Public Sub ResetHookVars() Implements IPlugin.ResetHookVars
        Roll_MemHook = 0
        Pitch_MemHook = 0
        Heave_MemHook = 0
        Yaw_MemHook = 0
        Sway_MemHook = 0
        Surge_MemHook = 0
        Extra1_MemHook = 0
        Extra2_MemHook = 0
        Extra3_MemHook = 0
    End Sub

    Public Sub ResetDashVars() Implements IPlugin.ResetDashVars
        Dash_1_Output = ""
        Dash_2_Output = ""
        Dash_3_Output = ""
        Dash_4_Output = ""
        Dash_5_Output = ""
        Dash_6_Output = ""
        Dash_7_Output = ""
        Dash_8_Output = ""
        Dash_9_Output = ""
        Dash_10_Output = ""
        Dash_11_Output = ""
        Dash_12_Output = ""
        Dash_13_Output = ""
        Dash_14_Output = ""
        Dash_15_Output = ""
        Dash_16_Output = ""
        Dash_17_Output = ""
        Dash_18_Output = ""
        Dash_19_Output = ""
        Dash_20_Output = ""
    End Sub

    Public ReadOnly Property PluginAuthorsName() As String Implements IPlugin.PluginAuthorsName
        Get
            Return _PluginAuthorsName
        End Get
    End Property

    Public ReadOnly Property Name() As String Implements IPlugin.Name
        Get
            Return _GameName
        End Get
    End Property

    Public ReadOnly Property ProcessName() As String Implements IPlugin.ProcessName
        Get
            Return _ProcessName
        End Get
    End Property

    Public ReadOnly Property Port() As String Implements IPlugin.Port
        Get
            Return _Port
        End Get
    End Property

    Public ReadOnly Property Is_MemoryMap() As Boolean Implements IPlugin.Is_MemoryMap
        Get
            Return _Is_MemoryMap
        End Get
    End Property

    Public ReadOnly Property Is_MemoryHook() As Boolean Implements IPlugin.Is_MemoryHook
        Get
            Return _Is_MemoryHook
        End Get
    End Property

    Public ReadOnly Property Is_DashBoard() As Boolean Implements IPlugin.Is_DashBoard
        Get
            Return _Is_DashBoard
        End Get
    End Property

    Public Function Get_RollOutput() As Double Implements IPlugin.Get_RollOutput
        Return Roll_Output
    End Function

    Public Function Get_Dash_1_Output() As String Implements IPlugin.Get_Dash1_Output
        Return Dash_1_Output
    End Function


    Public Function Get_Dash_2_Output() As String Implements IPlugin.Get_Dash2_Output
        Return Dash_2_Output
    End Function


    Public Function Get_Dash_3_Output() As String Implements IPlugin.Get_Dash3_Output
        Return Dash_3_Output
    End Function


    Public Function Get_Dash_4_Output() As String Implements IPlugin.Get_Dash4_Output
        Return Dash_4_Output
    End Function


    Public Function Get_Dash_5_Output() As String Implements IPlugin.Get_Dash5_Output
        Return Dash_5_Output
    End Function


    Public Function Get_Dash_6_Output() As String Implements IPlugin.Get_Dash6_Output
        Return Dash_6_Output
    End Function


    Public Function Get_Dash_7_Output() As String Implements IPlugin.Get_Dash7_Output
        Return Dash_7_Output
    End Function


    Public Function Get_Dash_8_Output() As String Implements IPlugin.Get_Dash8_Output
        Return Dash_8_Output
    End Function


    Public Function Get_Dash_9_Output() As String Implements IPlugin.Get_Dash9_Output
        Return Dash_9_Output
    End Function


    Public Function Get_Dash_10_Output() As String Implements IPlugin.Get_Dash10_Output
        Return Dash_10_Output
    End Function


    Public Function Get_Dash_11_Output() As String Implements IPlugin.Get_Dash11_Output
        Return Dash_11_Output
    End Function


    Public Function Get_Dash_12_Output() As String Implements IPlugin.Get_Dash12_Output
        Return Dash_12_Output
    End Function


    Public Function Get_Dash_13_Output() As String Implements IPlugin.Get_Dash13_Output
        Return Dash_13_Output
    End Function


    Public Function Get_Dash_14_Output() As String Implements IPlugin.Get_Dash14_Output
        Return Dash_14_Output
    End Function


    Public Function Get_Dash_15_Output() As String Implements IPlugin.Get_Dash15_Output
        Return Dash_15_Output
    End Function


    Public Function Get_Dash_16_Output() As String Implements IPlugin.Get_Dash16_Output
        Return Dash_16_Output
    End Function


    Public Function Get_Dash_17_Output() As String Implements IPlugin.Get_Dash17_Output
        Return Dash_17_Output
    End Function


    Public Function Get_Dash_18_Output() As String Implements IPlugin.Get_Dash18_Output
        Return Dash_18_Output
    End Function


    Public Function Get_Dash_19_Output() As String Implements IPlugin.Get_Dash19_Output
        Return Dash_19_Output
    End Function


    Public Function Get_Dash_20_Output() As String Implements IPlugin.Get_Dash20_Output
        Return Dash_20_Output
    End Function


    Public Function Get_PitchOutput() As Double Implements IPlugin.Get_PitchOutput
        Return Pitch_Output
    End Function

    Public Function Get_HeaveOutput() As Double Implements IPlugin.Get_HeaveOutput
        Return Heave_Output
    End Function

    Public Function Get_YawOutput() As Double Implements IPlugin.Get_YawOutput
        Return Yaw_Output
    End Function

    Public Function Get_SwayOutput() As Double Implements IPlugin.Get_SwayOutput
        Return Sway_Output
    End Function

    Public Function Get_SurgeOutput() As Double Implements IPlugin.Get_SurgeOutput
        Return Surge_Output
    End Function

    Public Function Get_Extra1Output() As Double Implements IPlugin.Get_Extra1Output
        Return Extra1_Output
    End Function

    Public Function Get_Extra2Output() As Double Implements IPlugin.Get_Extra2Output
        Return Extra2_Output
    End Function

    Public Function Get_Extra3Output() As Double Implements IPlugin.Get_Extra3Output
        Return Extra3_Output
    End Function

    Public Function Get_RollMemHook() As Double Implements IPlugin.Get_RollMemHook
        Return Roll_MemHook
    End Function

    Public Function Get_PitchMemHook() As Double Implements IPlugin.Get_PitchMemHook
        Return Pitch_MemHook
    End Function

    Public Function Get_HeaveMemHook() As Double Implements IPlugin.Get_HeaveMemHook
        Return Heave_MemHook
    End Function

    Public Function Get_YawMemHook() As Double Implements IPlugin.Get_YawMemHook
        Return Yaw_MemHook
    End Function

    Public Function Get_SwayMemHook() As Double Implements IPlugin.Get_SwayMemHook
        Return Sway_MemHook
    End Function

    Public Function Get_SurgeMemHook() As Double Implements IPlugin.Get_SurgeMemHook
        Return Surge_MemHook
    End Function

    Public Function Get_Extra1MemHook() As Double Implements IPlugin.Get_Extra1MemHook
        Return Extra1_MemHook
    End Function

    Public Function Get_Extra2MemHook() As Double Implements IPlugin.Get_Extra2MemHook
        Return Extra2_MemHook
    End Function

    Public Function Get_Extra3MemHook() As Double Implements IPlugin.Get_Extra3MemHook
        Return Extra3_MemHook
    End Function

    Public Function Get_RollMemMap() As Double Implements IPlugin.Get_RollMemMap
        Return Roll_MemMap
    End Function

    Public Function Get_PitchMemMap() As Double Implements IPlugin.Get_PitchMemMap
        Return Pitch_MemMap
    End Function

    Public Function Get_HeaveMemMap() As Double Implements IPlugin.Get_HeaveMemMap
        Return Heave_MemMap
    End Function

    Public Function Get_YawMemMap() As Double Implements IPlugin.Get_YawMemMap
        Return Yaw_MemMap
    End Function

    Public Function Get_SwayMemMap() As Double Implements IPlugin.Get_SwayMemMap
        Return Sway_MemMap
    End Function

    Public Function Get_SurgeMemMap() As Double Implements IPlugin.Get_SurgeMemMap
        Return Surge_MemMap
    End Function

    Public Function Get_Extra1MemMap() As Double Implements IPlugin.Get_Extra1MemMap
        Return Extra1_MemMap
    End Function

    Public Function Get_Extra2MemMap() As Double Implements IPlugin.Get_Extra2MemMap
        Return Extra2_MemMap
    End Function

    Public Function Get_Extra3MemMap() As Double Implements IPlugin.Get_Extra3MemMap
        Return Extra3_MemMap
    End Function

    'File Editor - Replaces a line in a txt/cfg file
    Private Sub MyFileEditor(FileName As String, LinetoEdit As String, StingReplacment As String)
        Dim lines As New List(Of String)
        Dim x As Integer = 0
        Using sr As New System.IO.StreamReader(FileName)
            While Not sr.EndOfStream
                lines.Add(sr.ReadLine)
            End While
        End Using

        For Each line As String In lines
            If line.Contains(LinetoEdit) Then
                lines.RemoveAt(x)
                lines.Insert(x, StingReplacment)
                Exit For 'must exit as we changed the iteration   
            End If
            x = x + 1
        Next

        Using sw As New System.IO.StreamWriter(FileName)
            For Each line As String In lines
                sw.WriteLine(line)
            Next
        End Using
        lines.Clear()
    End Sub

    'DeSerialize
    Public Function DeSerializeString(InputString As String) As Object
        On Error Resume Next
        Dim xml_serializer As New XmlSerializer(GetType(GenericOutput))
        Dim string_reader As New StringReader(InputString)
        Dim DeserializedOutput As GenericOutput = DirectCast(xml_serializer.Deserialize(string_reader), GenericOutput)
        string_reader.Close()
        Return DeserializedOutput
    End Function

    'Generic In/Output structure
    Public Structure GenericOutput
        Public _Roll As Double
        Public _Pitch As Double
        Public _Heave As Double
        Public _Yaw As Double
        Public _Sway As Double
        Public _Surge As Double
        Public _Extra1 As Double
        Public _Extra2 As Double
        Public _Extra3 As Double
    End Structure

    'memory hook function #1
    Public Function ReadSingle(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CInt(dwAddress), buffer, 4, 0)
            Dim MySingle As Single = BitConverter.ToSingle(buffer, 0)
            Return MySingle.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    'memory hook function #2
    Public Function ReadInt32(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CInt(dwAddress), buffer, 4, 0)
            Dim MyInt32 As Integer = BitConverter.ToInt32(buffer, 0)
            Return MyInt32.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function
#End Region
End Class